﻿using System;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

namespace IlNeige
{
    public partial class Flocon : UserControl, ISprite
    {
       

        // déplacement aléatoire sur l'horizontale
        private double hzDeplacement = 0d;

        // à true quand le flocon doit être supprimé (hors zone écran)
        private bool horsZone = false;

        public bool HorsZone
        {
            get { return horsZone; }
            set { horsZone = value; }
        }

        // échelle de base
        private static double scale = 0.09d;

        public UIElement Instance { get { return this; } }

        public Flocon()
        {
            InitializeComponent();

            // position initiale
            SetValue(Canvas.TopProperty, -10d);
            SetValue(Canvas.LeftProperty, (double)GameBoard.Random.Next(GameBoard.BoardWidth));

            // échelle initiale
            FlakeScale.ScaleX = FlakeScale.ScaleY = scale * GameBoard.Random.Next(1, 3);
            // rotation initiale
            FlakeRotation.Angle = GameBoard.Random.Next(1, 180);
        }

        public void Tombe()
        {
            // un peu de mystère
            var mereNature = GameBoard.Random.Next(40);

            if (mereNature == 1)
            {
                // changement de direction
                if (hzDeplacement >= 0.25 || hzDeplacement <= -0.25)
                    hzDeplacement = 0d;
                else
                {
                    var r = GameBoard.Random.Next(3);
                    if (r == 1) hzDeplacement = 0.25;
                    else
                        if (r == 2) hzDeplacement = -0.25;
                        else
                            hzDeplacement = 0d;
                }
            }
            var x = (double)GetValue(Canvas.LeftProperty);
            var y = (double)GetValue(Canvas.TopProperty);
            y++;
            x += hzDeplacement;
            SetValue(Canvas.LeftProperty, x);
            SetValue(Canvas.TopProperty, y);

            HorsZone = (x < 0 || x > GameBoard.BoardWidth || y > GameBoard.BoardHeight);
        }


    }
}