﻿using System;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Collections.Generic;

namespace IlNeige
{
    public partial class MainPage : UserControl
    {
        private List<ISprite> sprites = new List<ISprite>();
        private double density = 0.5d;

        public MainPage()
        {
            // Required to initialize variables
            InitializeComponent();
            App.Current.Host.Settings.MaxFrameRate = 40;
            CompositionTarget.Rendering += CompositionTarget_Rendering;
            Loaded += MainPage_Loaded;
        }

        void MainPage_Loaded(object sender, RoutedEventArgs e)
        {
            GameBoard.BoardWidth = 480;
            GameBoard.BoardHeight = 320;
        }

        private void CompositionTarget_Rendering(object sender, System.EventArgs e)
        {
            AnimerSprites();
            CreerSprites();
        }

        private void AnimerSprites()
        {
            var hs = new List<ISprite>();
            foreach (var f in sprites)
            {
                f.Tombe();
                if (f.HorsZone) hs.Add(f);
            }
            foreach (var f in hs)
            {
                sprites.Remove(f);
                Board.Children.Remove(f.Instance);
            }
        }

        private void CreerSprites()
        {
            ISprite sprite;
            if (GameBoard.Random.NextDouble() > density) return;
            if (GameBoard.Random.Next(0, 100) < 3)
            {
                // create a gif
                var c = GameBoard.Random.Next(0, 100);

                if (c > 75) sprite = new GiftBlue();
                else
                    if (c > 50) sprite = new GiftRed();
                    else
                        if (c > 25) sprite = new GiftGreen();
                        else sprite = new Merlin();

                sprites.Add(sprite);
                Board.Children.Add(sprite.Instance);
            }
            else
            {   // create a flake
                var fs = GameBoard.Random.Next(0, 3); // sprite à créer
                for (int i = 0; i <= fs; i++)
                {
                    sprite = new Flocon();
                    sprites.Add(sprite);
                    Board.Children.Add(sprite.Instance);
                }
            }

        }


        private void LayoutRoot_SizeChanged(object sender, SizeChangedEventArgs e)
        {
            GameBoard.BoardHeight = (int)e.NewSize.Height;
            GameBoard.BoardWidth = (int)e.NewSize.Width;
        }




    }

}