﻿using System;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

namespace IlNeige
{
    public partial class Merlin : UserControl, ISprite
    {
        public Merlin()
        {
            // Requis pour initialiser des variables
            InitializeComponent();

            // position initiale
            SetValue(Canvas.TopProperty, -100d);
            SetValue(Canvas.LeftProperty, (double)GameBoard.Random.Next(GameBoard.BoardWidth));

            // échelle initiale
            GiftScale.ScaleX = GiftScale.ScaleY = scale * GameBoard.Random.Next(1, 3);
            // rotation initiale
            GiftRotation.Angle = (45 - GameBoard.Random.Next(1, 90));
            VisualStateManager.GoToState(this, "LegendInvisible", false);
        }


        // déplacement aléatoire sur l'horizontale
        private double hzDeplacement = 0d;

        // à true quand le flocon doit être supprimé (hors zone écran)
        private bool horsZone = false;

        public bool HorsZone
        {
            get { return horsZone; }
            set { horsZone = value; }
        }

        // échelle de base
        private static double scale = 0.2d;

        public UIElement Instance { get { return this; } }


        public void Tombe()
        {
            // un peu de mystère
            var mereNature = GameBoard.Random.Next(40);

            if (mereNature == 1)
            {
                // changement de direction
                if (hzDeplacement >= 0.25 || hzDeplacement <= -0.25)
                    hzDeplacement = 0d;
                else
                {
                    var r = GameBoard.Random.Next(3);
                    if (r == 1) hzDeplacement = 0.25;
                    else
                        if (r == 2) hzDeplacement = -0.25;
                        else
                            hzDeplacement = 0d;
                }
            }
            var x = (double)GetValue(Canvas.LeftProperty);
            var y = (double)GetValue(Canvas.TopProperty);
            y++;
            x += hzDeplacement;
            SetValue(Canvas.LeftProperty, x);
            SetValue(Canvas.TopProperty, y);

            HorsZone = (x + 100 < 0 || x - 100 > GameBoard.BoardWidth || y - 100 > GameBoard.BoardHeight);
        }
    }
}